ZC706 with FMCOMMS3, Petalinux error

Hi,

I have implemented No-OS based design in ZC706 with FMCOMMS3. I'm able to transmit and receive data properly.

Now I want to implement IIO oscilloscope and want to see the received and transmitted data through it.. For that I started the design with linux.

I have installed petalinux 2017.3 in my system and followed the steps mentioned in https://wiki.analog.com/resources/tools-software/linux-build/generic/petalinux

I have used the .hdf file which generated from vivado for creating Petalinux project and configured as per document.

But when I'm trying to build the project using petalinux-build command, I'm getting an error msg which is attached here

[INFO] building project
[INFO] sourcing bitbake
INFO: bitbake petalinux-user-image
Loading cache: 100% |############################################| Time: 0:00:00
Loaded 683 entries from dependency cache.
ERROR: ExpansionError during parsing /home/mable/meta-adi/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-dev.bb
Traceback (most recent call last):
  File "/home/mable/Petalinux/components/yocto/source/arm/layers/core/bitbake/lib/bb/fetch2/__init__.py", line 1085, in srcrev_internal_helper(ud=<bb.fetch2.FetchData object at 0x7f6d26b42278>, d=<bb.data_smart.DataSmart object at 0x7f6d270e64e0>, name='default'):
         for a in attempts:
    >        srcrev = d.getVar(a, True)              
             if srcrev and srcrev != "INVALID":
  File "/home/mable/Petalinux/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 569, in DataSmart.getVar(var='SRCREV', expand=True, noweakdefault=False, parsing=False):
         def getVar(self, var, expand, noweakdefault=False, parsing=False):
    >        return self.getVarFlag(var, "_content", expand, noweakdefault, parsing)
     
  File "/home/mable/Petalinux/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 737, in DataSmart.getVarFlag(var='SRCREV', flag='_content', expand=True, noweakdefault=False, parsing=False):
                     cachename = var + "[" + flag + "]"
    >            value = self.expand(value, cachename)
     
  File "/home/mable/Petalinux/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 410, in DataSmart.expand(s='${@ "cc28af1e4e1d9a2deccbad98c6da51f83e52bef5" if bb.utils.to_boolean(d.getVar(\'BB_NO_NETWORK\')) else d.getVar(\'AUTOREV\')}', varname='SRCREV'):
         def expand(self, s, varname = None):
    >        return self.expandWithRefs(s, varname).value
     
  File "/home/mable/Petalinux/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 400, in DataSmart.expandWithRefs(s='${@ "cc28af1e4e1d9a2deccbad98c6da51f83e52bef5" if bb.utils.to_boolean(d.getVar(\'BB_NO_NETWORK\')) else d.getVar(\'AUTOREV\')}', varname='SRCREV'):
                 except Exception as exc:
    >                raise ExpansionError(varname, s, exc) from exc
     
bb.data_smart.ExpansionError: Failure expanding variable SRCREV, expression was ${@ "cc28af1e4e1d9a2deccbad98c6da51f83e52bef5" if bb.utils.to_boolean(d.getVar('BB_NO_NETWORK')) else d.getVar('AUTOREV')} which triggered exception TypeError: getVar() missing 1 required positional argument: 'expand'


Summary: There was 1 ERROR message shown, returning a non-zero exit code.
ERROR: Failed to build project
webtalk failed:PetaLinux statistics:extra lines detected:notsent_nofile!
webtalk failed:Failed to get PetaLinux usage statistics!

Parents
  • Hi,

    Please reply asap for this issue since I'm not able to move forward without solving this one.

    Hoping for a positive reply soon,

    Thanks,

    Mable George

  • 0
    •  Analog Employees 
    on May 26, 2020 8:30 AM 10 months ago in reply to mgeorge@cdot.in

    Hi Mable,

    It seems you are using an old petalinux/yocto version that uses different python API. Note that we do not support petalinux 2017.3. Moreover, if you want to use meta-adi master branch, you need petalinux 2019.1. Look at README for the master branch. If you switch to another branch you can use the same readme to know which versions should you use on hdl + petalinux.

    - Nuno Sá

  • I have installed Petalinux 2018.3 and cloned meta_adi_2019_R1 branch. When I'm using petalinux-build command  I'm getting error of "ERROR: ExpansionError during parsing /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb". My .gitconfig is fine. I'm able to clone git directories from terminal. So what might be the issue? Please find the attached log for more information.

    Expecting a reply asap since I'm not able to move forward without solving this one.

    mable@mable-VirtualBox:~/ad9361_v2018$ petalinux-config --get-hw-description=./
    INFO: Getting hardware description...
    INFO: Rename system_top.hdf to system.hdf
    [INFO] generating Kconfig for project
    [INFO] menuconfig project
    configuration written to /home/mable/ad9361_v2018/project-spec/configs/config
    
    *** End of the configuration.
    *** Execute 'make' to start the build or try 'make help'.
    
    [INFO] sourcing bitbake
    [INFO] generating plnxtool conf
    [INFO] generating meta-plnx-generated layer
    [INFO] generating machine configuration
    [INFO] generating bbappends for project . This may take time ! 
    [INFO] generating u-boot configuration files
    [INFO] generating kernel configuration files
    [INFO] generating kconfig for Rootfs
    [INFO] oldconfig rootfs
    [INFO] generating petalinux-user-image.bb
    mable@mable-VirtualBox:~/ad9361_v2018$ petalinux-build 
    [INFO] building project
    [INFO] sourcing bitbake
    INFO: bitbake petalinux-user-image
    Loading cache: 100% |############################################| Time: 0:00:00
    Loaded 914 entries from dependency cache.
    WARNING: /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb: Exception during build_dependencies for CXXFLAGS
    WARNING: /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb: Error during finalise of /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb
    ERROR: ExpansionError during parsing /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb
    Traceback (most recent call last):
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 412, in DataSmart.expandWithRefs(s='${LINUX_VERSION}-${ADI_VERSION}+git${SRCPV}', varname='PV'):
                     try:
        >                s = __expand_var_regexp__.sub(varparse.var_sub, s)
                         try:
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 111, in VariableParse.var_sub(match=<_sre.SRE_Match object; span=(35, 43), match='${SRCPV}'>):
                     else:
        >                var = self.d.getVarFlag(key, "_content")
                     self.references.add(key)
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 794, in DataSmart.getVarFlag(var='SRCPV', flag='_content', expand=True, noweakdefault=False, parsing=False):
                         cachename = var + "[" + flag + "]"
        >            value = self.expand(value, cachename)
         
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 436, in DataSmart.expand(s='${@bb.fetch2.get_srcrev(d)}', varname='SRCPV'):
             def expand(self, s, varname = None):
        >        return self.expandWithRefs(s, varname).value
         
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 426, in DataSmart.expandWithRefs(s='${@bb.fetch2.get_srcrev(d)}', varname='SRCPV'):
                     except Exception as exc:
        >                raise ExpansionError(varname, s, exc) from exc
         
    bb.data_smart.ExpansionError: Failure expanding variable SRCPV, expression was ${@bb.fetch2.get_srcrev(d)} which triggered exception FetchError: Fetcher failure: Fetch command export DBUS_SESSION_BUS_ADDRESS="unix:abstract=/tmp/dbus-6cAUU84yCh"; export SSH_AUTH_SOCK="/run/user/1000/keyring/ssh"; export GIT_SSL_CAINFO="/home/mable/Petalinux_2018.3/components/yocto/source/arm/buildtools/sysroots/x86_64-petalinux-linux/etc/ssl/certs/ca-certificates.crt"; export all_proxy="socks://webcache.cdotb.ernet.in:8080/"; export ALL_PROXY="socks://webcache.cdotb.ernet.in:8080/"; export no_proxy="localhost,127.0.0.0/8,::1"; export NO_PROXY="localhost,127.0.0.0/8,::1"; export ftp_proxy="ftp://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export https_proxy="https://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export http_proxy="http://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export PATH="/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/scripts:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/bin/arm-xilinx-linux-gnueabi:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot/usr/bin/crossscripts:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/sbin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/bin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/sbin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/microblaze/lin/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/aarch32/lin/gcc-arm-none-eabi/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/armr5/lin/gcc-arm-none-eabi/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/aarch64/lin/aarch64-none/bin:/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/bin:/home/mable/ad9361_v2018/build/tmp/hosttools"; export HOME="/home/mable"; git -c core.fsyncobjectfiles=0 ls-remote https://github.com/analogdevicesinc/linux.git  failed with exit code 128, output:
    fatal: unable to access 'https://github.com/analogdevicesinc/linux.git/': Received HTTP code 407 from proxy after CONNECT
    
    
    
    Summary: There were 2 WARNING messages shown.
    Summary: There was 1 ERROR message shown, returning a non-zero exit code.
    ERROR: Failed to build project
    
    

Reply
  • I have installed Petalinux 2018.3 and cloned meta_adi_2019_R1 branch. When I'm using petalinux-build command  I'm getting error of "ERROR: ExpansionError during parsing /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb". My .gitconfig is fine. I'm able to clone git directories from terminal. So what might be the issue? Please find the attached log for more information.

    Expecting a reply asap since I'm not able to move forward without solving this one.

    mable@mable-VirtualBox:~/ad9361_v2018$ petalinux-config --get-hw-description=./
    INFO: Getting hardware description...
    INFO: Rename system_top.hdf to system.hdf
    [INFO] generating Kconfig for project
    [INFO] menuconfig project
    configuration written to /home/mable/ad9361_v2018/project-spec/configs/config
    
    *** End of the configuration.
    *** Execute 'make' to start the build or try 'make help'.
    
    [INFO] sourcing bitbake
    [INFO] generating plnxtool conf
    [INFO] generating meta-plnx-generated layer
    [INFO] generating machine configuration
    [INFO] generating bbappends for project . This may take time ! 
    [INFO] generating u-boot configuration files
    [INFO] generating kernel configuration files
    [INFO] generating kconfig for Rootfs
    [INFO] oldconfig rootfs
    [INFO] generating petalinux-user-image.bb
    mable@mable-VirtualBox:~/ad9361_v2018$ petalinux-build 
    [INFO] building project
    [INFO] sourcing bitbake
    INFO: bitbake petalinux-user-image
    Loading cache: 100% |############################################| Time: 0:00:00
    Loaded 914 entries from dependency cache.
    WARNING: /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb: Exception during build_dependencies for CXXFLAGS
    WARNING: /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb: Error during finalise of /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb
    ERROR: ExpansionError during parsing /home/mable/ad9361_v2018/meta-adi-2019_R1/meta-adi-xilinx/recipes-kernel/linux/linux-xlnx_adi-2019_R1.bb
    Traceback (most recent call last):
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 412, in DataSmart.expandWithRefs(s='${LINUX_VERSION}-${ADI_VERSION}+git${SRCPV}', varname='PV'):
                     try:
        >                s = __expand_var_regexp__.sub(varparse.var_sub, s)
                         try:
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 111, in VariableParse.var_sub(match=<_sre.SRE_Match object; span=(35, 43), match='${SRCPV}'>):
                     else:
        >                var = self.d.getVarFlag(key, "_content")
                     self.references.add(key)
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 794, in DataSmart.getVarFlag(var='SRCPV', flag='_content', expand=True, noweakdefault=False, parsing=False):
                         cachename = var + "[" + flag + "]"
        >            value = self.expand(value, cachename)
         
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 436, in DataSmart.expand(s='${@bb.fetch2.get_srcrev(d)}', varname='SRCPV'):
             def expand(self, s, varname = None):
        >        return self.expandWithRefs(s, varname).value
         
      File "/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/lib/bb/data_smart.py", line 426, in DataSmart.expandWithRefs(s='${@bb.fetch2.get_srcrev(d)}', varname='SRCPV'):
                     except Exception as exc:
        >                raise ExpansionError(varname, s, exc) from exc
         
    bb.data_smart.ExpansionError: Failure expanding variable SRCPV, expression was ${@bb.fetch2.get_srcrev(d)} which triggered exception FetchError: Fetcher failure: Fetch command export DBUS_SESSION_BUS_ADDRESS="unix:abstract=/tmp/dbus-6cAUU84yCh"; export SSH_AUTH_SOCK="/run/user/1000/keyring/ssh"; export GIT_SSL_CAINFO="/home/mable/Petalinux_2018.3/components/yocto/source/arm/buildtools/sysroots/x86_64-petalinux-linux/etc/ssl/certs/ca-certificates.crt"; export all_proxy="socks://webcache.cdotb.ernet.in:8080/"; export ALL_PROXY="socks://webcache.cdotb.ernet.in:8080/"; export no_proxy="localhost,127.0.0.0/8,::1"; export NO_PROXY="localhost,127.0.0.0/8,::1"; export ftp_proxy="ftp://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export https_proxy="https://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export http_proxy="http://mgeorge:VsQ%25B06L@webcache.cdotb.ernet.in:8080/"; export PATH="/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/scripts:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/bin/arm-xilinx-linux-gnueabi:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot/usr/bin/crossscripts:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/sbin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/usr/bin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/sbin:/home/mable/ad9361_v2018/build/tmp/work/plnx_zynq7-xilinx-linux-gnueabi/linux-xlnx/fetcheravoidrecurse-R1/recipe-sysroot-native/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/microblaze/lin/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/aarch32/lin/gcc-arm-none-eabi/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/armr5/lin/gcc-arm-none-eabi/bin:/home/mable/Petalinux_2018.3/tools/xsct/SDK/2018.3/gnu/aarch64/lin/aarch64-none/bin:/home/mable/Petalinux_2018.3/components/yocto/source/arm/layers/core/bitbake/bin:/home/mable/ad9361_v2018/build/tmp/hosttools"; export HOME="/home/mable"; git -c core.fsyncobjectfiles=0 ls-remote https://github.com/analogdevicesinc/linux.git  failed with exit code 128, output:
    fatal: unable to access 'https://github.com/analogdevicesinc/linux.git/': Received HTTP code 407 from proxy after CONNECT
    
    
    
    Summary: There were 2 WARNING messages shown.
    Summary: There was 1 ERROR message shown, returning a non-zero exit code.
    ERROR: Failed to build project
    
    

Children
  • 0
    •  Analog Employees 
    on Feb 26, 2021 10:17 AM 1 month ago in reply to mgeorge@cdot.in

    Hi,

    So things are working for me:

    petalinux@620065fb39e5:/home/nunojsa/work/petalinux/2018_3/fmcomms3-zc706$ petalinux-build 
    [INFO] building project
    [INFO] sourcing bitbake
    INFO: bitbake petalinux-user-image
    Parsing recipes: 100% |#############################################################################################################################################################################| Time: 0:01:13
    Parsing of 2577 .bb files complete (0 cached, 2577 parsed). 3453 targets, 149 skipped, 0 masked, 0 errors.
    NOTE: Resolving any missing task queue dependencies
    Initialising tasks: 100% |##########################################################################################################################################################################| Time: 0:00:12
    Checking sstate mirror object availability: 100% |##################################################################################################################################################| Time: 0:00:14
    NOTE: Executing SetScene Tasks
    NOTE: Executing RunQueue Tasks
    WARNING: petalinux-user-image-1.0-r0 do_rootfs: [log_check] petalinux-user-image: found 1 warning message in the logfile:
    [log_check] warning: %post(sysvinit-inittab-2.88dsf-r10.plnx_zynq7) scriptlet failed, exit status 1
    
    NOTE: Tasks Summary: Attempted 3316 tasks of which 2381 didn't need to be rerun and all succeeded.
    
    Summary: There was 1 WARNING message shown.
    INFO: Copying Images from deploy to images
    INFO: Creating images/linux directory
    NOTE: Failed to copy built images to tftp dir:  /tftpboot
    [INFO] successfully built project
    petalinux@620065fb39e5:/home/nunojsa/work/petalinux/2018_3/fmcomms3-zc706$

    Make sure that you have all the necessary tools to build petalinux and that you have a supported distro. Also, I would recommend to just do a clean build if not the case. Maybe also just give a try to meta-adi docker image. It was what I used to test this project...

    - Nuno Sá

  • Hi Nuno,

    I have installed all required tools for ubuntu as mentioned in UG976. Any other tools are required or not?

    Since I'm not an expert in Ubuntu, can you guide me about usage of docker image? How to use it?

    I have searched online, But I didn't get any proper info..Please guide me regarding it..

    FYI :I'm running petalinux 2018.3 version in my virtual box.

    Thanks,

    Mable George

  • 0
    •  Analog Employees 
    on Mar 3, 2021 8:47 AM 1 month ago in reply to mgeorge@cdot.in

    Hi,

    One other thing. Are you sure you are using bash as your shell? Ubuntu uses dash by default... If you do "ls -la /bin/sh", what do you see?

    As for docker, there's plenty of things onlline on how to build docker images and how to run containers (docker is popular thing nowadays)... I would first search on how to install docker on ubuntu and then how to build a custom image. After that just build our petalinux image and try to run a container. Sorry, but here you need to do your own research work....

    - Nuno Sá

  • ls -la /bin/sh gives "bash" as result.

    Can you please provide the commands to run meta-adi docker image. I have tried my best to run https://wiki.analog.com/resources/tools-software/linux-build/generic/petalinux and it gives an error . So please provide a solution rather than asking me to do research work and all..

  • 0
    •  Analog Employees 
    on Mar 3, 2021 9:50 AM 1 month ago in reply to mgeorge@cdot.in

    Well,

    So please provide a solution rather than asking me to do research work and all..

    Sorry but teaching you how to run docker is out of the scope and there's plenty of information out there to use it. So as docker is concern, I'm really sorry but that's the most I can do... Pease understand that docker and meta-adi/petalinux are completely different things. We just provide a docker image to provide a clean environment (with all dependencies installed) independent from the host to build things. Now, people wanting to use it, well, it's assumed they know how to use docker...

    wiki.analog.com/.../quote]

    This might also explain some of your issues. I would recommend to follow this README. The wiki might be outdated and more reliable info is in github. Yes, this is bad and it's on my todo list to update wiki with up to date info...

    Also make sure that there's nothing wrong with your network and just try to start a clean build. At this point, I don't really know what's your issue as i cannot reproduce it on my side (it works fine).

    - Nuno Sá